<!--- 
CFAcademy
HOT 2
Security Basics
(c) 2012 Bilal Soylu

04-Api Design Layer
 --->

<!--- 
TASK:
Unify the current API to use the same security and access

 --->
component {

	// application variables
	this.name = "BusinessAccessControls";
	this.applicationtimeout = createTimeSpan(0,2,0,0);
	this.sessionmanagement = true;
	this.sessiontimeout = createTimeSpan(0,1,0,0);
	this.clientstorage = "cookie";
	
	
	// methods

	/**
	 * @hint The application first starts: the first request for a page is processed or the first CFC method is invoked by an event gateway instance, or a web services or Flash Remoting CFC.
	 */
	public boolean function onApplicationStart(){
		
		return true
	}

	/**
	 * @hint The application ends: the application times out, or the server is stopped
	 */
	public void function onApplicationEnd(ApplicationScope){

	}

	

	/**
	 * @hint A request starts
	 */
	public boolean function onRequestStart(String targetPage){
		if (NOT securityCheck(targetPage)) {
			//security check failed
			WriteOutput("Please login before trying to acces secure pages");
			return false;				
		} else {
			return true;				
		}
	}
	
	
	/**
	 * @hint check whether we are complying with access rules
	 */
	public boolean function securityCheck(String targetPage){
		var blnProceed=true;
		var strNormTarget = canonicalize(targetPage,true,true);
		
		//check whether is logged in before requesting secure pages
		if (strNormTarget contains "/secure/" AND NOT IsUserLoggedIn()) {
				blnProceed= false;				
		}
		 		
		return blnProceed;
	} 

	/**
	 * @hint All pages in the request have been processed:
	 */
	public void function onRequestEnd(String targetPage){
		
		
		WriteOutput("<h3>Pages to call</h3><hr noshade>");
		
		WriteOutput("<a href='PageAdd.cfm'>Add something</a><br>");
		WriteOutput("<a href='PageSubtract.cfm'>Subtract something</a><br>");		
		WriteOutput("<a href='secure/PageMultiply.cfm'>Multiply something</a><br>");
		WriteOutput("<a href='secure/PageDevide.cfm'>Devide something (admin only)</a><br>");
		
	}


	

}


